/*
 *Copyright (C) 1994-2000 The XFree86 Project, Inc. All Rights Reserved.
 *
 *Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 *"Software"), to deal in the Software without restriction, including
 *without limitation the rights to use, copy, modify, merge, publish,
 *distribute, sublicense, and/or sell copies of the Software, and to
 *permit persons to whom the Software is furnished to do so, subject to
 *the following conditions:
 *
 *The above copyright notice and this permission notice shall be
 *included in all copies or substantial portions of the Software.
 *
 *THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 *EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 *MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 *NONINFRINGEMENT. IN NO EVENT SHALL THE XFREE86 PROJECT BE LIABLE FOR
 *ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 *CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 *WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *Except as contained in this notice, the name of the XFree86 Project
 *shall not be used in advertising or otherwise to promote the sale, use
 *or other dealings in this Software without prior written authorization
 *from the XFree86 Project.
 *
 * Authors:	MATSUZAKI Kensuke
 */
#if 0
#undef XFree86Server
#include <windows.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <stdlib.h>
#include <X11/Xlocale.h>
#include "winwindow.h"

#define WIN_CONNECT_RETRIES	5
#define WIN_CONNECT_DELAY	5

void
winGetWindowName (Display * pDpy, Window iWin, char **ppName)
{
  int nResult, nNum;
  char **ppList;
  XTextProperty xtpName;

  *ppName = NULL;

  nResult = XGetWMName (pDpy, iWin, &xtpName);
  if (!nResult || !xtpName.value || !xtpName.nitems)
    return;

  if (xtpName.encoding == XA_STRING)
    {
      if (xtpName.value)
	{
	  //*ppName = strdup (xtpName.value);
	  //XFree (xtpName.value);
	}
    }
  else
    {
      XmbTextPropertyToTextList (pDpy, &xtpName, &ppList, &nNum);
      if (nNum && *ppList)
	{
	  XFree (xtpName.value);
	  //*ppName = strdup (*ppList);
	  //XFreeStringList (ppList);
	}
    }
}

DWORD WINAPI 
winRootlessWMProc (LPVOID lpParameter)
{
  MSG	                msg;
  Display               *pDisplay;
  Window                iWindow;
  winPrivWinPtr	        pWinPriv = NULL;
  int                   iRetries;
  static char                  *pszName;

  setlocale(LC_ALL, "");

  do {
    pDisplay = XOpenDisplay (NULL);
    if (pDisplay == NULL)
      {
	++iRetries;
	Sleep (WIN_CONNECT_DELAY*1000);
	continue;
      }
    else
      break;
  } while (pDisplay == NULL && iRetries < WIN_CONNECT_RETRIES);

  if (pDisplay == NULL)
    {
      exit (1);
    }
  /* Create message queue */
  PeekMessage(&msg, NULL, WM_USER, WM_USER, PM_NOREMOVE);

  /* Process all messages on our queue */
  while (GetMessage (&msg, NULL, 0, 0))
    {
      MessageBeep(0xffffffff);
      pWinPriv = (winPrivWinPtr)msg.wParam;
      iWindow = (Window)GetProp(pWinPriv->hWnd, WIN_WID_PROP);

      switch(msg.message)
	{
	case WM_WM_MOVE:
	  XMoveResizeWindow(pDisplay, iWindow,
			    pWinPriv->iX, pWinPriv->iY,
			    pWinPriv->iWidth, pWinPriv->iHeight);
	  break;
	case WM_WM_RAISE:
	  XRaiseWindow(pDisplay, iWindow);
	  break;
	case WM_WM_MAP:
	  winGetWindowName(pDisplay, iWindow, &pszName);
	  //SetWindowText (pWinPriv->hWnd, pszName);
	  XMapWindow(pDisplay, iWindow);
	  break;
	case WM_WM_UNMAP:
	  XUnmapWindow(pDisplay, iWindow);
	  break;
	default:
	  break;
	}
      XFlush (pDisplay);
    }
  return 0;
}

DWORD
winStartRootlessWM ()
{
#if 0
  HANDLE	hWMThread;
  DWORD         dwWMThread;

  hWMThread = CreateThread (NULL, 9, winRootlessWMProc, NULL,
			    0, &dwWMThread);
  ErrorF("winStartRootlessWM ()\n");
  ErrorF("\tThreadID %d\n", hWMThread);
  return dwWMThread;
#else
  return 0;
#endif
}
#else

#include "win.h"


DWORD
winStartRootlessWM ()
{
  return 0;
}

void
winSendMessageToWM (winWMMessagePtr pMsg)
{
  COPYDATASTRUCT cd;
  static DWORD dwID = 0;
  HWND hwndWM = FindWindow (WINDOW_CLASS_WM, WINDOW_TITLE_WM);


  if (hwndWM==NULL) return;
  
  pMsg->dwID = dwID++;
  cd.dwData = WMMSG_MSG;
  cd.cbData = sizeof(winWMMessageRec);
  cd.lpData = (PVOID)pMsg;
  
  ErrorF ("ID:%d ", pMsg->dwID);
  switch (pMsg->msg)
    {
    case WM_WM_MOVE:
      ErrorF ("WM_WM_MOVE\n");
      break;
    case WM_WM_RAISE:
      ErrorF ("WM_WM_RAISE\n");
      break;
    case WM_WM_LOWER:
      ErrorF ("WM_WM_RAISE\n");
      break;
    case WM_WM_MAP:
      ErrorF ("WM_WM_MAP\n");
      break;
    case WM_WM_UNMAP:
      ErrorF ("WM_WM_UNMAP\n");
      break;
    case WM_WM_KILL:
      ErrorF ("WM_WM_KILL\n");
      break;
    default:
      ErrorF ("Unknown Message.\n");
      break;
    }
  
  SendMessage(hwndWM, WM_COPYDATA, (WPARAM)pMsg->hwndWindow, (LPARAM)&cd);
}
#endif
